package impl

import (
	"golang.org/x/net/context"
	pb "git.loafle.net/overflow/crawler_go/grpc"
	"git.loafle.net/overflow/crawler_go"
)

type ConfigServerImpl struct {
	Crawlers map[string]crawler.Crawler
}

func (s *ConfigServerImpl) Add(c context.Context, in *pb.InputAdd) (*pb.Output, error) {
	output := &pb.Output{}
	if c, ok := s.Crawlers[in.Name.String()]; ok {
		rd, err := c.Add(in.Data)
		if err != nil {
			// process error
		}
		output.Data = rd
	} else {
		output.Data = []byte("Not Assign Crawler")
	}
	return output, nil
}
func (s *ConfigServerImpl) Remove(c context.Context, in *pb.Input) (*pb.Output, error) {
	output := &pb.Output{}
	if c, ok := s.Crawlers[in.Name.String()]; ok {
		rd, err := c.Remove(in.Id)
		if err != nil {
			// process error
		}
		output.Data = rd
	} else {
		output.Data = []byte("Not Assign Crawler")
	}
	return output, nil
}
func (s *ConfigServerImpl) Init(c context.Context, inputArray *pb.InputArray) (*pb.Output, error) {
	output := &pb.Output{}
	
	for _,in := range inputArray.In {
		if c, ok := s.Crawlers[in.Name.String()]; ok {
			rd, err := c.Init(in.Data)
			if err != nil {
				// process error
			}
			output.Data = rd
		} else {
			output.Data = []byte("Not Assign Crawler")
		}
	}
	return output, nil
}
