package impl

import (
	"golang.org/x/net/context"
	pb "git.loafle.net/overflow/crawler_go/grpc"
	"git.loafle.net/overflow/crawler_go"
)

type DataServerImpl struct {
	Crawlers map[string]crawler.Crawler
}

func (s *DataServerImpl) Get(c context.Context, in *pb.Input) (*pb.Output, error) {

	output := &pb.Output{}

	if c, ok := s.Crawlers[in.Name.String()]; ok {
		rd, err := c.Get(in.Id)
		if err != nil {
			// process error
		}
		output.Data = rd
	} else {
		output.Data = []byte("Not Assign Crawler")
	}
	return output, nil
}
